/***
   source: GNU PUBLIC LICENCE (2)
   wrote:  S.Nifont, serg-nifont@yandex.ru, 2012
	   Borland C 3.1, DOS
-------------------------------------------------

 encodong:  CP-866, cyrillic.

    ⪠ ᤥ  '檨 '

     2  - 104 .

    4 ஫  4 㧠 몫뢠 ࠧ.  ஫
      ᮡ  室饬 浪,
     㧮 -  室饬.

    16  -    ⮯.   뢠  
     室.

    ⠫  몫뢠 묨, ⠪   
     ਬ몠  ॡ 㣮.

    ,    ᢮ ,  室묨 
      ५  楫 8 ⮯.

     ਣ쭮   - 8*8 ,   
    ᬠਢ 2 ࠧ.
       
    :
        () " ᮢ" ᪫,,
***/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <conio.h>
#include <dos.h>

#include <assert.h>

int screen_width, screen_height; // text mode 40*25 ?

#define CHERVY 0
#define BUBI   1
#define KRESTI 2
#define PIKI   3


enum {K_2, K_3, K_4, K_5, K_6, K_7, K_8,
      K_9, K_10, JACK, DAMA, KING, ACE} Kard_id;




struct Kard{
  int mast, // 0..3
      dost; // 0..12
}kards[104]; // 2 kolody

#define _         (-1)
#define W         23
#define PLACE_SZ (W*W)
#define PLACE_CNT 90

int place[PLACE_SZ]={
 _,  _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
 _,  _, 0, 1, _, _, 2, _, 3, _, 4, _, 5, _, 6, _, 7, _, 8, _, 9, _, _,
 _,  _, 0, 1, _, _, 2, _, 3, _, 4, _, 5, _, 6, _, 7, _, 8, _, 9, _, _,
 _,  _, 0, 1, _, _, 2, _, 3, _, 4, _, 5, _, 6, _, 7, _, 8, _, 9, _, _,
 _,  _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
 _,  _,10, _, _, _,12, _, _, _,14, _, _, _,16, _, _, _,18, _, _, _, _,
 _,  _,10,11,11,11,12,13,13,13,14,15,15,15,16,17,17,17,18,19,19,19, _,
 _,  _,10, _,21, _,12, _,23, _,14, _,25, _,16, _,27, _,18, _,29, _, _,
 _, 20,20,20,21,22,22,22,23,24,24,24,25,26,26,26,27,28,28,28,29, _, _,
 _,  _,30, _,21, _,32, _,23, _,34, _,25, _,36, _,27, _,38, _,29, _, _,
 _,  _,30,31,31,31,32,33,33,33,34,35,35,35,36,37,37,37,38,39,39,39, _,
 _,  _,30, _,41, _,32, _,43, _,34, _,45, _,36, _,47, _,38, _,49, _, _,
 _, 40,40,40,41,42,42,42,43,44,44,44,45,46,46,46,47,48,48,48,49, _, _,
 _,  _,50, _,41, _,52, _,43, _,54, _,45, _,56, _,47, _,58, _,49, _, _,
 _,  _,50,51,51,51,52,53,53,53,54,55,55,55,56,57,57,57,58,59,59,59, _,
 _,  _,50, _,61, _,52, _,63, _,54, _,65, _,56, _,67, _,58, _,69, _, _,
 _, 60,60,60,61,62,62,62,63,64,64,64,65,66,66,66,67,68,68,68,69, _, _,
 _,  _,70, _,61, _,72, _,63, _,74, _,65, _,76, _,67, _,78, _,69, _, _,
 _,  _,70,71,71,71,72,73,73,73,74,75,75,75,76,77,77,77,78,79,79,79, _,
 _,  _,70, _,81, _,72, _,83, _,74, _,85, _,76, _,87, _,78, _,89, _, _,
 _, 80,80,80,81,82,82,82,83,84,84,84,85,86,86,86,87,88,88,88,89, _, _,
 _,  _, _, _,81, _, _, _,83, _, _, _,85, _, _, _,87, _, _, _,89, _, _,
 _,  _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _
};

int place_kard_id[PLACE_CNT][32]; // pool of kard for each place
int place_kard_cnt[PLACE_CNT];    // count of kard for each place


int first_kard_sq[PLACE_CNT];
int kard_dir[PLACE_CNT];

#define BOARD_LEFT 2
#define BOARD_TOP  2

#define KARTA   1
#define OBLOJKA 2
#define EMPTY   4   //ࠥ 
#define BORDER  8   //    
#define SELECT  16  // 뤥
#define ACSEPT  32  // ࠭


//-----------------------------

void insert_kard(int kard_id, int place_N){
  assert(kard_id >= 0 && kard_id < 104);
  assert(place_N >= 0 && place_N < PLACE_CNT);
  assert(place_kard_cnt[place_N] < 32);

  place_kard_id [ place_N ][ place_kard_cnt[place_N]++ ] = kard_id;
}

int remove_kard(int place_N){
  assert(place_N >= 0 && place_N < PLACE_CNT);
  assert(place_kard_cnt[place_N] > 0);

  return  place_kard_id [ place_N ][ --place_kard_cnt[place_N] ];
}


save_game(){
 FILE *f = fopen("last_game","wb");
 if(f)
 {
  fwrite(place_kard_id, 1, sizeof(place_kard_id), f);
  fwrite(place_kard_cnt, 1, sizeof(place_kard_cnt), f);
  fclose(f);
 }
}

load_game(){
 FILE *f = fopen("last_game","rb");
 if(f)
 {
  fread(place_kard_id, 1, sizeof(place_kard_id), f);
  fread(place_kard_cnt, 1, sizeof(place_kard_cnt), f);
  fclose(f);
  return 1;
 }
 return 0;
}


void init(){
 int j,k;
 int koloda[104];
 int koloda_cnt;


 //clear
 for(j = 0; j < PLACE_CNT; j++)
 {
   place_kard_cnt[j] = 0;
   first_kard_sq[j] = 0;
   kard_dir[j] = 0;
 }

 for(j = 0; j < PLACE_CNT; j++)
  for(k = 0; k < 32; k++)
   place_kard_id[j][k] = 0;



			       // init kards
 for(j = 0; j < 104; j++)
 {
   kards[j].mast = (j%52) / 13;
   kards[j].dost = (j%52) % 13;
 }

				// clear board
 for(j = 0; j < PLACE_CNT; j++)
 {
   place_kard_cnt[j] = 0;
   first_kard_sq[j]  = -1;

 }

 //init first square for each kard and dir
 for(j = 0; j < PLACE_SZ; j++)
  if(place[j] != -1)
   if(first_kard_sq[place[j]]==-1)
   {
     first_kard_sq[place[j]] = j;
     if(place[j+W]==place[j])
       kard_dir[place[j]] = W;
     else
       kard_dir[place[j]] = 1;
   }

 //६   -   - 
 for(j = 0; j < 104; j++)
 {
   koloda[j] = j;
 }
 koloda_cnt = 104;

 //4 ஫  4 㧠 -  
 for(j = 0; j < 4; j++)
 {
  insert_kard(j*13 + KING, 2+j);
  koloda[j*13 + KING] = -1;

  insert_kard(j*13 + ACE, 2+4+j);
  koloda[j*13 + ACE] = -1;
 }




 //ᤢ   - ( -1)  砫 ᨢ
 koloda_cnt = 0;
 for(j = 0; j < 104; j++)
  if(koloda[j] != -1)
  {
    koloda[koloda_cnt++] = koloda[j];
  }
 assert(koloda_cnt == 104-8);

 //६蠥 ⠢ 
 srand(time(0));
 for(j = 0; j < 1000; j++)
 {
   int N1 = rand()%koloda_cnt;
   int N2 = rand()%koloda_cnt;
   int tmp = koloda[N1]; koloda[N1] = koloda[N2]; koloda[N2] = tmp;
//   assert(koloda_cnt>0);
 }

 // 16  -  
 for(j = 0; j < 16; j++)
 {
   insert_kard(koloda[--koloda_cnt], 0);
 }

 //⠫  -  
 for(j = 10; j < PLACE_CNT; j++)
 {
   assert(koloda_cnt>0);
   insert_kard(koloda[--koloda_cnt], j);
 }
 assert(koloda_cnt==0);
}
//--------------------------------


int select_id, acsept_id;

show(){
  int is_show[PLACE_CNT];
  int j;

  for(j = 0; j < PLACE_CNT; j++)
   is_show[j] = 0;

  for(j = 0; j < PLACE_SZ; j++)
  {
    if(place[j] != -1)
     if(is_show[place[j]]==0)
     {
       int id = 0;
       int kard_N = 0;

       is_show[place[j]] = 1;

       switch(place[j])
       {
	case 0:                     // 
	{
	 if(place_kard_cnt[0] == 0)     // 
	   id = BORDER;
	 else
	   id = OBLOJKA;
	}break;
	case 1:				//  
	{
	  if(place_kard_cnt[1] <= 0)
	   id = BORDER;
	  else
	  {
	   id = KARTA;
	   kard_N = place_kard_id[ place[j]] [place_kard_cnt[place[j]]-1];
	  }
	}break;
	default:			//    
	{
	  if(place_kard_cnt[place[j]] > 0)
	  {
	   id = KARTA;
	   kard_N = place_kard_id[ place[j]] [place_kard_cnt[place[j]]-1];
	  }else
	   id = BORDER;
	}break;
       }//switch
       if(place[j]==select_id)          // 
	   id |= SELECT;
       if(place[j]==acsept_id)
	   id |= ACSEPT;

       show_kard(      kard_N,                   // kard,
		       BOARD_LEFT + j%W,    // x - koor
		       BOARD_TOP  + j/W,    // y - koor
		       id,
		       kard_dir[place[j]]==W //is_vertical
		);
     }//if
  }//for


  return 0;
}//endp


/****
#define KARTA   1
#define OBLOJKA 2
#define EMPTY   4
#define BORDER  8
#define SELECT  16
#define ACSEPT  32
*****/
int foo;

show_kard(int kard, int x, int y, int show_id, int is_vertical){
 const char ch_kard[] = "23456789YJDKA";
 const char ch_mast[] = {3,4,5,6};

 int d_x,d_y;

 if(is_vertical) d_x = 0, d_y = 1;
 else d_x = 1, d_y = 0;


 //??
 if(kard < 0 || kard > 104-1)
  foo++;

 gotoxy(x,y);

// switch(show_id)
// {
   if(show_id & KARTA)
   {
     int mast = (kard%52)/13;
     int dost = (kard%52)%13;
     int mast_color = mast <= BUBI ? (12&~8) : (9|16);
     int fon_color;

     //if( show_id==KARTA )
     fon_color = 7;                           //
     if( show_id & SELECT)
	fon_color = 2; //
     if( show_id & ACSEPT)
	fon_color = 3; //㡮


     //??
     //if(mast < 0 || mast > 3)
     // foo++;
     //if(dost < 0 || dost >= 13)
     // foo++;


     //textattr((fon_color<<4) | mast_color);  // !!! not work with Borland C 3.1 ?
     textbackground(fon_color);
     textcolor(mast_color);

     cprintf("%c", ch_mast[mast]);
     gotoxy(x+=d_x, y+=d_y);
     cprintf(" ");
     gotoxy(x+=d_x, y+=d_y);
     cprintf("%c", ch_kard[dost]);

   }else if(show_id & OBLOJKA)
   {
     //??
     //return 0;

     textattr(3<<4 | 0);    // (fon << 4)  | text
     cprintf("%c", '#');
     gotoxy(x+=d_x, y+=d_y);
     cprintf("#");
     gotoxy(x+=d_x, y+=d_y);
     cprintf("%c", '#');

   }else if(show_id & (BORDER | EMPTY))
   {
     int fon=0;
     if(show_id & BORDER) fon = 1;
     if(show_id & EMPTY)  fon = 0;


    //??
    //return 0;

     textattr(fon<<4 | 0);    // (fon << 4)  | text
     cprintf("%c", ' ');
     gotoxy(x+=d_x, y+=d_y);
     cprintf(" ");
     gotoxy(x+=d_x, y+=d_y);
     cprintf("%c", ' ');
   }




 return 0;
}
//-----------------------------------
#define TAB   9
#define SPACE 32
#define ESC   27
#define LEFT  75
#define RIGHT 77
#define ENTER 13

//get from
//return value
#define UNKNOW     -1
#define USER_ABORT -2
// select kard 0..PLACE_CNT-1 頥  ࠭ 


int msgdlg(char s[]){
 int x,y;

   x = screen_width/2 - strlen(s)/2;
   if(x < 1) x = 1;
   y = screen_height/2;

   gotoxy(x,y);

   textattr( (1<<4) | 15 );
   cprintf("%s", s);

   switch(getch())
   {
     case 'y': case 'Y': case ENTER:
       return 1;
     default:
       return 0;
   }

}//endp


int get_to(){

  //acsept_id = -3;
  select_id =  2; //first place number

  show();

  for(;;)
  {
    int ch = getch();

    switch(ch) //    2..2+8-1
    {
      case LEFT:  if(--select_id < 2) select_id = 9; show(); break;
      case RIGHT: if(++select_id > 9) select_id = 2; show(); break;
      case ENTER:
	{
	   acsept_id = select_id;
	   show();
	   return acsept_id;
	}break;
      case ESC:  return USER_ABORT;
    }//switch

  }//for
  return UNKNOW;
}//endp
//----------------------------------------
//⮨⢮      52*2 
int kard_dost(int kard){
 int d = (kard%52)%13 + 1;
 if(d == 13) //ACE
  d = 0;
 return d;
}
//-------------------------------------------
void beep(){
 sound(300);
 delay(50);
 nosound();
}


//------------------------------
loop(){
  static int first_load = 0;

new_game:

  textbackground(0);
  textcolor(7);
  clrscr();

  show_msg("           Turkish rug", 1, 1);

  show_msg("Space - list\n",        26, 10);
  show_msg("Left,Right-move  \n",   26, 12);
  show_msg("Enter - get  \n",       26, 14);
  show_msg("Esc   - exit\n",        26, 16);

  show_status("new game");



   //init();
   hint_kard_place();
   if(first_load==0)
   {
     load_game();
     first_load = 1;
   }

   select_id = acsept_id = -3;

   show();


  //main loop
  for(;;)
  {
    int from,to,kard,from_k,to_k,ok;


    show_status("Choose a card");

    from = get_from();  //get_from();
    if(from < 0)
    {
       if(msgdlg("Play new game? (y/n)"))
	goto new_game;
       goto end; //user abort
    }

// get_to_kard:


    show_status("Choose a location (1..8)");

    to = get_to();  //get_from();
    if(to < 0)
    {
       if(msgdlg("Play new game? (y/n)"))
	goto new_game;
       goto end; //user abort
    }

    from_k = place_kard_id [from] [ place_kard_cnt[from]-1 ] ;
    to_k   = place_kard_id [to  ] [ place_kard_cnt[to  ]-1 ] ;
    ok = 0;

    if( (from_k%52)/13 == (to_k%52)/13 ) // 
     // 0 1  2 3 4 5  6 7 8 9
     //      king's     ace's
     if( to <= 5)
     {
      //ᮡࠥ  ஫  뢠
      if( kard_dost(from_k) == kard_dost(to_k)-1 )
       ok = 1;

     }else{
      //ᮡࠥ  㧮  ⠭
      if( kard_dost(from_k) == kard_dost(to_k)+1 )
       ok = 1;
     }

     if(ok)
     {
      int j;
      kard = remove_kard(from);    // move kard
      insert_kard(kard, to);
      select_id = acsept_id = -3;
      show();
      //-------------------
      //஢ઠ  砭
      for(j = 2; j < 2+8; j++)
       if(place_kard_cnt[j] != 13)
	goto not_end;

	if(msgdlg("Congratulation! Play new? (y/n)"))
	{
	  goto new_game;
	}

      not_end:
      j=j;
      //-------------------
     }else{
      show_status("error");
      beep();
      delay(500);
      //goto get_to_kard;
     }
  }//for


end:

  textbackground(0);
  textcolor(7);
  clrscr();

  return 0;
}
//------------------------------
/*
  ࠧ ,   ࠧ
     ࠧ
*/
hint_kard_place(){

 static int list[100], list_cnt=0;// 楯窠 ࠧ饭    砫
 int target_numbers[8] = {2,3,4,5,6,7,8,9}; //楫 

 static int on_king[13] = {
   KING,DAMA,JACK,K_10,K_9,K_8,K_7,K_6,K_5,K_4,K_3,K_2,ACE
 };
 static int on_ace[13] =  {
   ACE,K_2,K_3,K_4,K_5,K_6,K_7,K_8,K_9,K_10,JACK,DAMA,KING
 };
 int j, find;
// int cnt;

 hint_list( list, &list_cnt);

 for(j = 0; j < PLACE_CNT; j++)
   place_kard_cnt[j] = 0;    //   

 //樠㥬 8 ⮯   楫  -
 //  ⮢ 楫 ᪫


 //#define CHERVY 0  BUBI 1  KRESTI 2  PIKI 3
 // 0 1  2 3 4 5  6 7 8 9
 for(j = 0; j < 13; j++)
 {
   insert_kard( on_king[j] + 13*CHERVY, 2);
   insert_kard( on_king[j] + 13*BUBI  , 3);
   insert_kard( on_king[j] + 13*KRESTI, 4);
   insert_kard( on_king[j] + 13*PIKI  , 5);

   insert_kard( on_ace [j] + 13*CHERVY, 6);
   insert_kard( on_ace [j] + 13*BUBI  , 7);
   insert_kard( on_ace [j] + 13*KRESTI, 8);
   insert_kard( on_ace [j] + 13*PIKI  , 9);
 }




 // ६     8   
 //       (ᮣ᭮ ᯨ᪠)

// cnt = 0;


 do{
   find = 0;


    //६蠥 楫 
    for(j = 0; j < 10; j++)
    {
     int N1 = rand()%8;
     int N2 = rand()%8;
     int tmp = target_numbers[N1];
     target_numbers[N1] = target_numbers[N2];
     target_numbers[N2] = tmp;
    }




   for(j = 0; j < 8; j++) // ⮯ 
   {
     int N = target_numbers[j];

     if(place_kard_cnt[N] > 1) // ᫥ 
     {
       if(rand()%3==0 && place_kard_cnt[0] < 16)
       {
	  //⠢  
	 int K = remove_kard(N);
	 insert_kard(K, 0);
	 find = 1;

       }else if(list_cnt > 0){
	 //⠢  
	 int K = remove_kard(N);
	 insert_kard(K, list[--list_cnt]);
	 find = 1;
       }else if(place_kard_cnt[0] < 16)
       {
	  //⠢  
	 int K = remove_kard(N);
	 insert_kard(K, 0);
	 find = 1;
       }else{
	  //   訡
	  goto end_work;
       }
     }//endif
     if(find) break; // 1  - 
   }//for j

 }while(find);

 end_work:

 return 0;
}

//--------------------------------
/*
  ᯨ᮪  ᪫
  稭  ࠩ   
  業ࠫ쭮
  !!!  ᭮  
  ⮬  맢 init
*/
hint_list( int ret_list[100], int *ret_list_cnt){

  int list[PLACE_CNT], list_cnt=0;
  int N;

  srand(time(0));
  init();
  *ret_list_cnt = 0;

  while(can_move_list(list, &list_cnt))
  {
     N = list[rand()%list_cnt];
     ret_list[(*ret_list_cnt)++] = N;
     remove_kard(N);
  }
  return *ret_list_cnt;
}


//--------------------------------
can_move_list(int list[PLACE_CNT], int *list_cnt){


     int prob[PLACE_CNT];
     int j;
     int cnt;

     *list_cnt = 0;

   for(j = 0; j < PLACE_CNT; j++) prob[j] = 0;

     //稬 ᯨ᮪ ,   室
   for(j = 0; j < PLACE_SZ; j++)
    if(place[j] != -1)
       if(prob[place[j]]==0)   //  ᬮਬ   ࠧ
			//⮫쪮 孥  
       {
	prob[place[j]] = 1;
	assert(first_kard_sq[place[j]] == j); // ᮩ

	if(place[j] >= 2+8 || place[j]==1) //   室
	 if((cnt=place_kard_cnt[place[j]]) > 0) // 
	 {
	   int can_move = 0;
	   int kard_id = place_kard_id[place[j]] [cnt-1];
	   int mast = (kard_id%52) / 13;
	   int dost = (kard_id%52) % 13;
	   //᫨   ᢮ 

	   can_move = 0;
	   if(place[j]==1)
	   {                // ,  ᥣ  室
	     if(place_kard_cnt[1] > 0)
	     {
	       can_move = 1;
	     }
	   }else{
	    int SQ1,SQ2;
	    // ஢ ,  宨  ⮫쪮 ᫨
	    //᢮ 
	    if(kard_dir[place[j]]==W) //ਪ쭠 
	    {
	      SQ1 = j - W;
	      SQ2 = j + W + W + W;
	    }else{
	      SQ1 = j - 1;
	      SQ2 = j + 1 + 1 + 1;
	    }
	    if( //          
		( place[SQ1]==-1  ||  place_kard_cnt[place[SQ1]] <= 0)
				||
		( place[SQ2]==-1  ||  place_kard_cnt[place[SQ2]] <= 0)
	      )
	    {
	      //  室
	      can_move = 1;
	    }//endif
	   }//endif place[j]==0
	   //--------

	   if(can_move==1)
	   {
	     //----------
	     //諨    室,    ᨢ
	     //室
	     list[(*list_cnt)++] = place[j];
	     //----------
	   }
	   //--------
	 }//endif cnt =  ... > 0
      }//endif prob[j]==0
//---------------------------
   return *list_cnt > 0;
}





int get_from(){
 int ch,j;
  //  
 acsept_id = -3; //祣  ࠭
 select_id = -3;


 for(;;)
 {
  ch = getch();
  if(ch==SPACE) //⠥ 
  {
    // 0 -    1 -    
    if(place_kard_cnt[0] > 0) //   
    {
       insert_kard(remove_kard(0), 1); //  0   1

    }else if(place_kard_cnt[1] > 0) {   //頥   

      for(j = 0; j < place_kard_cnt[1]; j++)
	place_kard_id [0] [j] = place_kard_id [1] [j];

      place_kard_cnt[0] = place_kard_cnt[1];
      place_kard_cnt[1] = 0;
    }
    show();

  }else if(ch==ESC){

     return USER_ABORT;

  }else if(ch==0 || ch==ENTER){ // ?? left,right or enter
    //------------------------------------------
     int list[PLACE_CNT];
     int list_cnt=0;

     int j;
     int cnt;


     if(ch==0)
       ch = getch(); // spetial key


   if(ch==LEFT || ch==RIGHT || ch==ENTER)
   {
   //001----------------
     //稬 ᯨ᮪ ,   室
     can_move_list(list, &list_cnt);

      //諨 , ⮡ 室?
      if(list_cnt > 0)
      {
	 static int from = 0;

	 if(ch==LEFT) from--;
	 else if(ch==RIGHT) from++;

	 if(from < 0) from = list_cnt-1;
	 if(from >= list_cnt) from = 0;

	 if(ch==ENTER)
	   acsept_id = list[from];
	 else
	   select_id = list[from];
	 show();

	 if(ch==ENTER)
	  return acsept_id; // USER CHOISE KART
      }
     //001------------------------
   }//endif ch==LEFT || ch==RIGHT
   //---------------------------
  }//endif (ch=getch())==0


 }//for

 return UNKNOW;
}



no_mouse(){
  asm{
    mov ax, 0 // reset driver
    int 0x33

    cmp ax,0
    jz not_find
      mov ax,2     // hide mouse pointer :))
      int 0x33
  }
  not_find:
  return 0;
}


show_msg(char msg[], int x, int y){

  gotoxy(x,y);
  textattr( (0<<4) | 7 );
  cprintf("%s",msg);
}

show_status(char msg[]){
 int j;
 textbackground(0);//1-BLUE
 textcolor(7); //white low
 for(j = 1; j <= 39; /*screen_width*/j++)
 {
   gotoxy(j, screen_height);
   cprintf(" ");
 }
 gotoxy(2, screen_height);
 cprintf("%s", msg);
}

main(){

int i;
/******
  do{
    static int list[100], cnt,j;
//    FILE *f = fopen
    hint_list( list, &cnt);
    for(j = 0; j<cnt; j++)
     printf("%d ", list[j]);
    printf("\n");
  }while(0);
****/



  textmode(C40); //25*40
  screen_width  = 40;
  screen_height = 25;

  no_mouse();


  //??
//  hint_kard_place();
//  show();
//  getch();






//  clrscr();


//   init();
//   show();

   loop();

  /****
  show_kard(0, 1, 1, KARTA, 1);
  show_kard(0, 3, 3, KARTA, 0);

  show_kard(0, 7, 7, OBLOJKA, 0);

  show_kard(0, 7, 9, BORDER, 0);
  show_kard(0, 7, 11, EMPTY, 0);
  show_kard(0, 7, 13, SELECT, 0);
  show_kard(0, 7, 15, ACSEPT, 0);
  ***/

  //getch();


/*********
  for (i=0; i<16; i++)
  {
    textattr( (i << 4) | 0 );
    cprintf(" color %d, ch %c  \r\n", i, i);
  }
  getch();
 *********/

 save_game();

 textmode(C80);
 cprintf("  '檨 ', serg-nifont@yandex.ru, %s \n", __DATE__);

 return 0;
}


